// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPAccountDesc.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPAccountDesc Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPAccountDesc.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPAccountDesc*)
{
    new TDPAccountDesc(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpaccountdesc
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPAccountDesc)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPAccountDesc::TDPAccountDesc()
// Description: The default constructor for the TDPAccountDesc object.
// --------------------------------------------------------------------------
__fastcall TDPAccountDesc::TDPAccountDesc(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDPAccountDesc::~TDPAccountDesc()
// Description: The destructor for the TDPAccountDesc object.
// --------------------------------------------------------------------------
__fastcall TDPAccountDesc::~TDPAccountDesc()
{
}
// --------------------------------------------------------------------------
// Property:    AccountID
// Description: The AccountID property references the account identifier, 
//              stored as a Unicode string. 
//              
//              The account identifier uniquely describes a player who is 
//              logged in to a secure session. 
//              
//              The account identifier's format will vary depending on the 
//              Security Support Provider Interface (SSPI) package that is 
//              being used. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPAccountDesc::FGetAccountID()
{
if ((LPWSTR)fAccountID.c_str()!=fDPACCOUNTDESC.lpszAccountID)
    fAccountID = fDPACCOUNTDESC.lpszAccountID;
return fAccountID;
}
// --------------------------------------------------------------------------
void __fastcall TDPAccountDesc::FSetAccountID( AnsiString pAccountID )
{
fAccountID = pAccountID;
fDPACCOUNTDESC.lpszAccountID = (LPWSTR) fAccountID.c_str();
}
// --------------------------------------------------------------------------
// Property:    AccountIDA
// Description: The AccountID property references the account identifier, 
//              stored as a ANSI string. 
//              
//              The account identifier uniquely describes a player who is 
//              logged in to a secure session. 
//              
//              The account identifier's format will vary depending on the 
//              Security Support Provider Interface (SSPI) package that is 
//              being used. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPAccountDesc::FGetAccountIDA()
{
if ((LPSTR)fAccountIDA.c_str()!=fDPACCOUNTDESC.lpszAccountIDA)
    fAccountIDA = fDPACCOUNTDESC.lpszAccountIDA;
return fAccountIDA;
}
// --------------------------------------------------------------------------
void __fastcall TDPAccountDesc::FSetAccountIDA( AnsiString pAccountIDA )
{
fAccountIDA = pAccountIDA;
fDPACCOUNTDESC.lpszAccountIDA = (LPSTR) fAccountIDA.c_str();
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPAccountDesc method or fget/fset. 
//              eg. DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPAccountDesc::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPAccountDesc::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DPACCOUNTDESC structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPAccountDesc::FGetSize()
{
return fDPACCOUNTDESC.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPAccountDesc::FSetSize( dword pSize )
{
fDPACCOUNTDESC.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPAccountDesc's internal DPACCOUNTDESC structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPAccountDesc::Clear()
{
fErrorValue = DP_OK;
fDPACCOUNTDESC.dwSize = sizeof(DPACCOUNTDESC);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPACCOUNTDESC* __fastcall TDPAccountDesc::FGetInternal_DPACCOUNTDESC_Ptr()
{
return &fDPACCOUNTDESC;
}
// --------------------------------------------------------------------------
void __fastcall TDPAccountDesc::FSetInternal_DPACCOUNTDESC( DPACCOUNTDESC* pDPACCOUNTDESC )
{
if (pDPACCOUNTDESC==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPAccountDesc::FSetInternal_DPACCOUNTDESC()", "TDX_ERROR", "The supplied DPACCOUNTDESC* was NULL" );
    return;
    }

CopyMemory( &fDPACCOUNTDESC, pDPACCOUNTDESC, sizeof(DPACCOUNTDESC) );
Internal_DPACCOUNTDESC_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPAccountDesc::Internal_DPACCOUNTDESC_Update()
{
}

// --------------------------------------------------------------------------
