// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPCompoundAddressElement.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the 
//               TDPCompoundAddressElement Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPCompoundAddressElement.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPCompoundAddressElement*)
{
    new TDPCompoundAddressElement(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpcompoundaddresselement
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPCompoundAddressElement)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPCompoundAddressElement::TDPCompoundAddressElement()
// Description: The default constructor for the TDPCompoundAddressElement object.
// --------------------------------------------------------------------------
__fastcall TDPCompoundAddressElement::TDPCompoundAddressElement(TComponent* Owner)
    : TComponent(Owner)
{
fDPCOMPOUNDADDRESSELEMENT=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TDPCompoundAddressElement::~TDPCompoundAddressElement()
// Description: The destructor for the TDPCompoundAddressElement object.
// --------------------------------------------------------------------------
__fastcall TDPCompoundAddressElement::~TDPCompoundAddressElement()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              DPCOMPOUNDADDRESSELEMENT structures wrapped inside the 
//              TDPCompoundAddressElement component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TDPCompoundAddressElement component wraps a single 
//              DPCOMPOUNDADDRESSELEMENT structure. To wrap multiple 
//              structures, set the TDPCompoundAddressElement::ArraySize to 
//              the total number of internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TDPCompoundAddressElement::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fDPCOMPOUNDADDRESSELEMENT;
    fDPCOMPOUNDADDRESSELEMENT = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fDPCOMPOUNDADDRESSELEMENT = new DPCOMPOUNDADDRESSELEMENT[pArraySize];
    if (fDPCOMPOUNDADDRESSELEMENT==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDPCOMPOUNDADDRESSELEMENT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DPCOMPOUNDADDRESSELEMENT structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        DPCOMPOUNDADDRESSELEMENT* temp_DPCOMPOUNDADDRESSELEMENT = new DPCOMPOUNDADDRESSELEMENT[pArraySize];
        if (temp_DPCOMPOUNDADDRESSELEMENT==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TDPCOMPOUNDADDRESSELEMENT::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal DPCOMPOUNDADDRESSELEMENT structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_DPCOMPOUNDADDRESSELEMENT[fArraySize], sizeof(DPCOMPOUNDADDRESSELEMENT)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_DPCOMPOUNDADDRESSELEMENT[0], &fDPCOMPOUNDADDRESSELEMENT[0], sizeof(DPCOMPOUNDADDRESSELEMENT)*fArraySize);
        // de-allocate old memory
        delete[] fDPCOMPOUNDADDRESSELEMENT;
        // re-assign the new memory
        fDPCOMPOUNDADDRESSELEMENT = temp_DPCOMPOUNDADDRESSELEMENT;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            DPCOMPOUNDADDRESSELEMENT* temp_DPCOMPOUNDADDRESSELEMENT = new DPCOMPOUNDADDRESSELEMENT[pArraySize];
            if (temp_DPCOMPOUNDADDRESSELEMENT==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TDPCOMPOUNDADDRESSELEMENT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DPCOMPOUNDADDRESSELEMENT structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_DPCOMPOUNDADDRESSELEMENT[0], &fDPCOMPOUNDADDRESSELEMENT[0], sizeof(DPCOMPOUNDADDRESSELEMENT)*pArraySize);
            // de-allocate the old memory
            delete[] fDPCOMPOUNDADDRESSELEMENT;
            // re-assign the new memory
            fDPCOMPOUNDADDRESSELEMENT = temp_DPCOMPOUNDADDRESSELEMENT;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    Data
// Description: The Data property references the data to be used to create 
//              the compound address. 
// --------------------------------------------------------------------------
void* __fastcall TDPCompoundAddressElement::FGetData( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FGetData()", "TDX_ERROR", "Internal Array size is 0.");
     return (void*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FGetData()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (void*) NULL;
    }

return fDPCOMPOUNDADDRESSELEMENT[pArrayIndex].lpData;
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::FSetData( dword pArrayIndex, void* pData )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FSetData()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FSetData()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDPCOMPOUNDADDRESSELEMENT[pArrayIndex].lpData = pData;
}
// --------------------------------------------------------------------------
// Property:    DataSize
// Description: The DataSize property defines the size, in bytes, of the data 
//              referenced by TDPCompoundAddressElement::Data. 
// --------------------------------------------------------------------------
dword __fastcall TDPCompoundAddressElement::FGetDataSize( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FGetDataSize()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FGetDataSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDPCOMPOUNDADDRESSELEMENT[pArrayIndex].dwDataSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::FSetDataSize( dword pArrayIndex, dword pDataSize )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FSetDataSize()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FSetDataSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDPCOMPOUNDADDRESSELEMENT[pArrayIndex].dwDataSize = pDataSize;
}
// --------------------------------------------------------------------------
// Property:    DataType
// Description: The DataType property identifies the type of data referenced 
//              by TDPCompoundAddressElement::Data. 
//              
//              The predefined GUIDs are : 
//              
//              DPAID_ComPort 
//              The Data property references a TDPComportAddress component 
//              defining COM port settings. 
//              
//              DPAID_INet 
//              The Data property references an ANSI representation of an IP 
//              or domain address. 
//              For Example: "220.150.10.102" or "game.com". 
//              Using an empty string ("") causes the Internet TCP/IP 
//              connection service provider enumerate active sessions on the 
//              specified network address or broadcast on the subnet. 
//              TDPCompoundAddressElement::DataSize must include the 
//              terminator. 
//              
//              DPAID_INetW 
//              The Data property references a unicode representation of an 
//              IP or domain address. 
//              For Example: "220.150.10.102" or "game.com". 
//              Using an empty string ("") causes the Internet TCP/IP 
//              connection service provider enumerate active sessions on the 
//              specified network address or broadcast on the subnet. 
//              TDPCompoundAddressElement::DataSize must include the 
//              terminator. 
//              
//              DPAID_INetPort 
//              The Data property references an integer specifying which port 
//              number to use for communications. 
//              
//              DPAID_LobbyProvider   
//              The Data property references a 16-byte GUID identifying the 
//              lobby provider the address applies to. 
//              
//              DPAID_Modem 
//              The Data property references a NULL terminated ANSI value 
//              specifying which modem to use. 
//              Available modems can be determined with 
//              TDx_Play::GetPlayerAddress(). 
//              TDPCompoundAddressElement::DataSize must include the 
//              terminator. 
//              
//              DPAID_ModemW 
//              The Data property references a NULL terminated unicode value 
//              specifying which modem to use. 
//              Available modems can be determined with 
//              TDx_Play::GetPlayerAddress(). 
//              TDPCompoundAddressElement::DataSize must include the 
//              terminator. 
//                 
//              DPAID_Phone 
//              The Data property references an ANSI value defining a phone 
//              number. 
//              The modem service provider will call this number when 
//              TDx_Play::EnumSessions() is called. 
//              If no modem is specified, the first available modem will be 
//              used. 
//              TDPCompoundAddressElement::DataSize must include the 
//              terminator. 
//              
//              DPAID_PhoneW 
//              The Data property references a unicode value defining a phone 
//              number. 
//              The modem service provider will call this number when 
//              TDx_Play::EnumSessions() is called. 
//              If no modem is specified, the first available modem will be 
//              used. 
//              TDPCompoundAddressElement::DataSize must include the 
//              terminator. 
//              
//              DPAID_ServiceProvider 
//              The Data property references a 16-byte GUID identifying the 
//              service provider the address applies to. 
//              
//              DPAID_TotalSize 
//              The Data property references a dword holding the size of the 
//              internal DPADDRESS structure. 
//              This chunk is automatically added by 
//              TDx_PlayLobby::CreateCompoundAddress. 
// --------------------------------------------------------------------------
GUID __fastcall TDPCompoundAddressElement::FGetDataType( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FGetDataType()", "TDX_ERROR", "Internal Array size is 0.");
    return fDataType;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FGetDataType()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return fDataType;
    }

return fDPCOMPOUNDADDRESSELEMENT[pArrayIndex].guidDataType;
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::FSetDataType( dword pArrayIndex, GUID pDataType )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FSetDataType()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::FSetDataType()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDPCOMPOUNDADDRESSELEMENT[pArrayIndex].guidDataType = pDataType;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPCompoundAddressElement method or 
//              fget/fset. eg. DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPCompoundAddressElement::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal DPCOMPOUNDADDRESSELEMENT structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPCompoundAddressElement::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal DPCOMPOUNDADDRESSELEMENT structures. This result is 
//              the same as multiplying TDPCompoundAddressElement::ArraySize 
//              and TDPCompoundAddressElement::Size. 
// --------------------------------------------------------------------------
dword __fastcall TDPCompoundAddressElement::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPCompoundAddressElement's internal DPCOMPOUNDADDRESSELEMENT 
//              structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TDPCompoundAddressElement::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fDPCOMPOUNDADDRESSELEMENT[pArrayIndex], sizeof(DPCOMPOUNDADDRESSELEMENT) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal DPCOMPOUNDADDRESSELEMENT structures of the 
//              TDPCompoundAddressElement component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDPCompoundAddressElement::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fDPCOMPOUNDADDRESSELEMENT[0], sizeof(DPCOMPOUNDADDRESSELEMENT)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
DPCOMPOUNDADDRESSELEMENT* __fastcall TDPCompoundAddressElement::FGetInternal_DPCOMPOUNDADDRESSELEMENT_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPCompoundAddressElement::FGetInternal_DPCOMPOUNDADDRESSELEMENT_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fDPCOMPOUNDADDRESSELEMENT;
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::FSetInternal_DPCOMPOUNDADDRESSELEMENT( dword pArrayIndex, DPCOMPOUNDADDRESSELEMENT* pDPCOMPOUNDADDRESSELEMENT )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPCompoundAddressElement::FSetInternal_DPCOMPOUNDADDRESSELEMENT()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pDPCOMPOUNDADDRESSELEMENT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPCompoundAddressElement::FSetInternal_DPCOMPOUNDADDRESSELEMENT()", "TDX_ERROR", "The supplied DPCOMPOUNDADDRESSELEMENT* was NULL" );
    return;
    }
CopyMemory( &fDPCOMPOUNDADDRESSELEMENT[pArrayIndex], pDPCOMPOUNDADDRESSELEMENT, sizeof(DPCOMPOUNDADDRESSELEMENT) );
Internal_DPCOMPOUNDADDRESSELEMENT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPCompoundAddressElement::Internal_DPCOMPOUNDADDRESSELEMENT_Update()
{
}

// --------------------------------------------------------------------------
