// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPLAppInfo.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPLAppInfo Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPLAppInfo.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPLAppInfo*)
{
    new TDPLAppInfo(NULL);
}
// --------------------------------------------------------------------------
namespace Tdplappinfo
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPLAppInfo)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPLAppInfo::TDPLAppInfo()
// Description: The default constructor for the TDPLAppInfo object.
// --------------------------------------------------------------------------
__fastcall TDPLAppInfo::TDPLAppInfo(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDPLAppInfo::~TDPLAppInfo()
// Description: The destructor for the TDPLAppInfo object.
// --------------------------------------------------------------------------
__fastcall TDPLAppInfo::~TDPLAppInfo()
{
}
// --------------------------------------------------------------------------
// Property:    AppName
// Description: The AppNameA property references the name of the application 
//              being enumerated, stored as a unicode string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPLAppInfo::FGetAppName()
{
if ((LPWSTR)fAppName.c_str()!=fDPLAPPINFO.lpszAppName)
    fAppName = fDPLAPPINFO.lpszAppName;
return fAppName;
}
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::FSetAppName( AnsiString pAppName )
{
fAppName = pAppName;
fDPLAPPINFO.lpszAppName = (LPWSTR) fAppName.c_str();
}
// --------------------------------------------------------------------------
// Property:    AppNameA
// Description: The AppNameA property references the name of the application 
//              being enumerated, stored as an ANSI string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPLAppInfo::FGetAppNameA()
{
if ((LPSTR)fAppNameA.c_str()!=fDPLAPPINFO.lpszAppNameA)
    fAppNameA = fDPLAPPINFO.lpszAppNameA;
return fAppNameA;
}
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::FSetAppNameA( AnsiString pAppNameA )
{
fAppNameA = pAppNameA;
fDPLAPPINFO.lpszAppNameA = (LPSTR) fAppNameA.c_str();
}
// --------------------------------------------------------------------------
// Property:    Application
// Description: The Application property identifies the application being 
//              enumerated. 
// --------------------------------------------------------------------------
GUID __fastcall TDPLAppInfo::FGetApplication()
{
return fDPLAPPINFO.guidApplication;
}
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::FSetApplication( GUID pApplication )
{
fDPLAPPINFO.guidApplication = pApplication;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPLAppInfo method or fget/fset. 
//              eg. DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPLAppInfo::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DPLAPPINFO structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPLAppInfo::FGetSize()
{
return fDPLAPPINFO.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::FSetSize( dword pSize )
{
fDPLAPPINFO.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPLAppInfo's internal DPLAPPINFO structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::Clear()
{
ZeroMemory(&fApplication,sizeof(_GUID));
fErrorValue = DP_OK;
fDPLAPPINFO.dwSize = sizeof(DPLAPPINFO);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPLAPPINFO* __fastcall TDPLAppInfo::FGetInternal_DPLAPPINFO_Ptr()
{
return &fDPLAPPINFO;
}
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::FSetInternal_DPLAPPINFO( DPLAPPINFO* pDPLAPPINFO )
{
if (pDPLAPPINFO==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPLAppInfo::FSetInternal_DPLAPPINFO()", "TDX_ERROR", "The supplied DPLAPPINFO* was NULL" );
    return;
    }

CopyMemory( &fDPLAPPINFO, pDPLAPPINFO, sizeof(DPLAPPINFO) );
Internal_DPLAPPINFO_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPLAppInfo::Internal_DPLAPPINFO_Update()
{
}

// --------------------------------------------------------------------------
