// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPLConnection.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPLConnection Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPLConnection.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPLConnection*)
{
    new TDPLConnection(NULL);
}
// --------------------------------------------------------------------------
namespace Tdplconnection
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPLConnection)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPLConnection::TDPLConnection()
// Description: The default constructor for the TDPLConnection object.
// --------------------------------------------------------------------------
__fastcall TDPLConnection::TDPLConnection(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDPLConnection::~TDPLConnection()
// Description: The destructor for the TDPLConnection object.
// --------------------------------------------------------------------------
__fastcall TDPLConnection::~TDPLConnection()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    Address
// Description: The Address property references the address needed by the 
//              service provider to connect to a session. 
//              
//              This address will usually have been created using 
//              TDx_PlayLobby::CreateCompoundAddress(). 
//              Refer to TDPCompoundAddressElement::DataType for address type 
//              and size information. 
// --------------------------------------------------------------------------
void* __fastcall TDPLConnection::FGetAddress()
{
return fDPLCONNECTION.lpAddress;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetAddress( void* pAddress )
{
fDPLCONNECTION.lpAddress = pAddress;
}
// --------------------------------------------------------------------------
// Property:    AddressSize
// Description: The AddressSize property defines the size, in bytes, of the 
//              address data referenced by TDPLConnection::Address 
//              
//              Refer to TDPCompoundAddressElement::DataType for address type 
//              and size information. 
// --------------------------------------------------------------------------
dword __fastcall TDPLConnection::FGetAddressSize()
{
return fDPLCONNECTION.dwAddressSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetAddressSize( dword pAddressSize )
{
fDPLCONNECTION.dwAddressSize = pAddressSize;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPLConnection method or fget/fset. 
//              eg. DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPLConnection::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating whether the 
//              session is to be created or joined. 
//              The described effect applies when the flag is set. 
// Flags:       DPLCONNECTION_CREATESESSION -
//                Create a new session as described by the TDPSessionDesc 
//                component referenced by TDPLConnection::SessionDesc. 
//              DPLCONNECTION_JOINSESSION -
//                Join the exisiting session described by the TDPSessionDesc 
//                component referenced by TDPLConnection::SessionDesc. 
// --------------------------------------------------------------------------
dword __fastcall TDPLConnection::FGetFlags()
{
return fDPLCONNECTION.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetFlags( dword pFlags )
{
fDPLCONNECTION.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    PlayerName
// Description: The PlayerName property references a TDPName component 
//              holding the players name. 
//              
//              This name is the same as that registered in the lobby. 
//              This name may be ignored by the application. 
// --------------------------------------------------------------------------
TDPName* __fastcall TDPLConnection::FGetPlayerName()
{
if (ComponentState.Contains(csDesigning) &&
    (fPlayerName!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fPlayerName)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fPlayerName=NULL;
    }
return fPlayerName;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetPlayerName( TDPName* pPlayerName )
{
fPlayerName = pPlayerName;
fDPLCONNECTION.lpPlayerName = pPlayerName->Internal_DPNAME_Ptr;
}
// --------------------------------------------------------------------------
// Property:    SP
// Description: The SP property identifies the service provider to be used 
//              for connecting to the session. 
//              
//              Predefined service provide GUIDS include : 
//              
//              DPSPGUID_TCPIP 
//              DPSPGUID_IPX 
//              DPSPGUID_MODEM 
//              DPSPGUID_SERIAL 
// --------------------------------------------------------------------------
GUID __fastcall TDPLConnection::FGetSP()
{
return fDPLCONNECTION.guidSP;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetSP( GUID pSP )
{
fDPLCONNECTION.guidSP = pSP;
}
// --------------------------------------------------------------------------
// Property:    SessionDesc
// Description: The SessionDesc property references a TDPSessionDesc 
//              component describing the session to be created or joined. 
// --------------------------------------------------------------------------
TDPSessionDesc* __fastcall TDPLConnection::FGetSessionDesc()
{
if (ComponentState.Contains(csDesigning) &&
    (fSessionDesc!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSessionDesc)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSessionDesc=NULL;
    }
return fSessionDesc;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetSessionDesc( TDPSessionDesc* pSessionDesc )
{
fSessionDesc = pSessionDesc;
fDPLCONNECTION.lpSessionDesc = pSessionDesc->Internal_DPSESSIONDESC2_Ptr;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDPLConnection::FGetSize()
{
return fDPLCONNECTION.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetSize( dword pSize )
{
fDPLCONNECTION.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPLConnection's internal DPLCONNECTION structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::Clear()
{
fDPLCONNECTION.lpAddress = NULL;
fDPLCONNECTION.dwAddressSize = 0;
fErrorValue = DP_OK;
fDPLCONNECTION.dwFlags = 0;
fPlayerName = NULL;
fDPLCONNECTION.lpPlayerName = NULL;
ZeroMemory(&fSP,sizeof(_GUID));
fSessionDesc = NULL;
fDPLCONNECTION.lpSessionDesc = NULL;
fDPLCONNECTION.dwSize = sizeof(DPLCONNECTION);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPLCONNECTION* __fastcall TDPLConnection::FGetInternal_DPLCONNECTION_Ptr()
{
return &fDPLCONNECTION;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetInternal_DPLCONNECTION( DPLCONNECTION* pDPLCONNECTION )
{
if (pDPLCONNECTION==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPLConnection::FSetInternal_DPLCONNECTION()", "TDX_ERROR", "The supplied DPLCONNECTION* was NULL" );
    return;
    }

CopyMemory( &fDPLCONNECTION, pDPLCONNECTION, sizeof(DPLCONNECTION) );
Internal_DPLCONNECTION_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::Internal_DPLCONNECTION_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDPLConnection_Flags_Set<> of the flags 
//              in the current fDPLCONNECTION.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDPLConnection_Flags_Set __fastcall TDPLConnection::FGetFlags_()
{
TDPLConnection_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDPLCONNECTION.dwFlags & DPLCONNECTION_CREATESESSION) TempFlags_ = TempFlags_ << dplconnection_createsession;
if (fDPLCONNECTION.dwFlags & DPLCONNECTION_JOINSESSION) TempFlags_ = TempFlags_ << dplconnection_joinsession;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDPLConnection::FSetFlags_( TDPLConnection_Flags_Set pFlags_ )
{
fDPLCONNECTION.dwFlags = 0;
if (pFlags_.Contains(dplconnection_createsession)) fDPLCONNECTION.dwFlags |= DPLCONNECTION_CREATESESSION;
if (pFlags_.Contains(dplconnection_joinsession)) fDPLCONNECTION.dwFlags |= DPLCONNECTION_JOINSESSION;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDPLConnection::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDPLConnection::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDPLCONNECTION.dwFlags & DPLCONNECTION_CREATESESSION) fFlags_Strings->Add("DPLCONNECTION_CREATESESSION");
if (fDPLCONNECTION.dwFlags & DPLCONNECTION_JOINSESSION) fFlags_Strings->Add("DPLCONNECTION_JOINSESSION");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
