
// ==========================================================================
// File:        TDx_Play_Library_Functions.CPP
// Description: This file implements standard functions used with the 
//              TDx_Play_Library components.
//
// "TDx_Play_Library"
// (c) 2002, BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

#include <vcl\vcl.h>
#pragma hdrstop

// --------------------------------------------------------------------------
#include "TDx_Library_Defns.H"
#include "TDx_Library_Functions.H"
// --------------------------------------------------------------------------
#include "TDx_Play_Library_Defns.H"
#include "TDx_Play_Library_Functions.H"

// --------------------------------------------------------------------------
// Func:            TDx_Play_Library_ErrorString()
// Description:     Use this function to return the name of the error.
// --------------------------------------------------------------------------
AnsiString __fastcall TDx_Play_Library_ErrorString(int Error)
{
AnsiString str = TDx_Library_ErrorString(Error);
if (str!="") return str;
switch (Error)
    {
    case -1: str = "TDX_ERROR"; break;
    case DP_OK: str = "DP_OK"; break;
    case DPERR_ABORTED: str = "DPERR_ABORTED"; break;
    case DPERR_ACCESSDENIED: str = "DPERR_ACCESSDENIED"; break;
    case DPERR_ACTIVEPLAYERS: str = "DPERR_ACTIVEPLAYERS"; break;
    case DPERR_ALREADYINITIALIZED: str = "DPERR_ALREADYINITIALIZED"; break;
    case DPERR_ALREADYREGISTERED: str = "DPERR_ALREADYREGISTERED"; break;
    case DPERR_APPNOTSTARTED: str = "DPERR_APPNOTSTARTED"; break;
    case DPERR_AUTHENTICATIONFAILED: str = "DPERR_AUTHENTICATIONFAILED"; break;
    case DPERR_BUFFERTOOLARGE: str = "DPERR_BUFFERTOOLARGE"; break;
    case DPERR_BUFFERTOOSMALL: str = "DPERR_BUFFERTOOSMALL"; break;
    case DPERR_BUSY: str = "DPERR_BUSY"; break;
    case DPERR_CANCELFAILED: str = "DPERR_CANCELFAILED"; break;
    case DPERR_CANCELLED: str = "DPERR_CANCELLED"; break;
    case DPERR_CANNOTCREATESERVER: str = "DPERR_CANNOTCREATESERVER"; break;
    case DPERR_CANTADDPLAYER: str = "DPERR_CANTADDPLAYER"; break;
    case DPERR_CANTCREATEGROUP: str = "DPERR_CANTCREATEGROUP"; break;
    case DPERR_CANTCREATEPLAYER: str = "DPERR_CANTCREATEPLAYER"; break;
    case DPERR_CANTCREATEPROCESS: str = "DPERR_CANTCREATEPROCESS"; break;
    case DPERR_CANTCREATESESSION: str = "DPERR_CANTCREATESESSION"; break;
    case DPERR_CANTLOADCAPI: str = "DPERR_CANTLOADCAPI"; break;
    case DPERR_CANTLOADSECURITYPACKAGE: str = "DPERR_CANTLOADSECURITYPACKAGE"; break;
    case DPERR_CANTLOADSSPI: str = "DPERR_CANTLOADSSPI"; break;
    case DPERR_CAPSNOTAVAILABLEYET: str = "DPERR_CAPSNOTAVAILABLEYET"; break;
    case DPERR_CONNECTING: str = "DPERR_CONNECTING"; break;
    case DPERR_CONNECTIONLOST: str = "DPERR_CONNECTIONLOST"; break;
    case DPERR_ENCRYPTIONFAILED: str = "DPERR_ENCRYPTIONFAILED"; break;
    case DPERR_ENCRYPTIONNOTSUPPORTED: str = "DPERR_ENCRYPTIONNOTSUPPORTED"; break;
    case DPERR_EXCEPTION: str = "DPERR_EXCEPTION"; break;
    case DPERR_GENERIC: str = "DPERR_GENERIC"; break;
    case DPERR_INVALIDFLAGS: str = "DPERR_INVALIDFLAGS"; break;
    case DPERR_INVALIDGROUP: str = "DPERR_INVALIDGROUP"; break;
    case DPERR_INVALIDINTERFACE: str = "DPERR_INVALIDINTERFACE"; break;
    case DPERR_INVALIDOBJECT: str = "DPERR_INVALIDOBJECT"; break;
    case DPERR_INVALIDPARAMS: str = "DPERR_INVALIDPARAMS"; break;
    case DPERR_INVALIDPASSWORD: str = "DPERR_INVALIDPASSWORD"; break;
    case DPERR_INVALIDPLAYER: str = "DPERR_INVALIDPLAYER"; break;
    case DPERR_INVALIDPRIORITY: str = "DPERR_INVALIDPRIORITY"; break;
    case DPERR_LOGONDENIED: str = "DPERR_LOGONDENIED"; break;
    case DPERR_NOCAPS: str = "DPERR_NOCAPS"; break;
    case DPERR_NOCONNECTION: str = "DPERR_NOCONNECTION"; break;
    case DPERR_NOINTERFACE: str = "DPERR_NOINTERFACE"; break;
    case DPERR_NOMEMORY: str = "DPERR_NOMEMORY"; break;
    case DPERR_NOMESSAGES: str = "DPERR_NOMESSAGES"; break;
    case DPERR_NONAMESERVERFOUND: str = "DPERR_NONAMESERVERFOUND"; break;
    case DPERR_NONEWPLAYERS: str = "DPERR_NONEWPLAYERS"; break;
    case DPERR_NOPLAYERS: str = "DPERR_NOPLAYERS"; break;
    case DPERR_NOSERVICEPROVIDER: str = "DPERR_NOSERVICEPROVIDER"; break;
    case DPERR_NOSESSIONS: str = "DPERR_NOSESSIONS"; break;
    case DPERR_NOTHANDLED: str = "DPERR_NOTHANDLED"; break;
    case DPERR_NOTLOBBIED: str = "DPERR_NOTLOBBIED"; break;
    case DPERR_NOTLOGGEDIN: str = "DPERR_NOTLOGGEDIN"; break;
    case DPERR_NOTREGISTERED: str = "DPERR_NOTREGISTERED"; break;
    case DPERR_PENDING: str = "DPERR_PENDING"; break;
    case DPERR_PLAYERLOST: str = "DPERR_PLAYERLOST"; break;
    case DPERR_SERVICEPROVIDERLOADED: str = "DPERR_SERVICEPROVIDERLOADED"; break;
    case DPERR_SENDTOOBIG: str = "DPERR_SENDTOOBIG"; break;
    case DPERR_SESSIONLOST: str = "DPERR_SESSIONLOST"; break;
    case DPERR_SIGNFAILED: str = "DPERR_SIGNFAILED"; break;
    case DPERR_TIMEOUT: str = "DPERR_TIMEOUT"; break;
    case DPERR_UNAVAILABLE: str = "DPERR_UNAVAILABLE"; break;
    case DPERR_UNINITIALIZED: str = "DPERR_UNINITIALIZED"; break;
    case DPERR_UNKNOWNAPPLICATION: str = "DPERR_UNKNOWNAPPLICATION"; break;
    case DPERR_UNKNOWNMESSAGE: str = "DPERR_UNKNOWNMESSAGE"; break;
    case DPERR_UNSUPPORTED: str = "DPERR_UNSUPPORTED"; break;
    case DPERR_USERCANCEL: str = "DPERR_USERCANCEL"; break;
    default: str = "UNKNOWN ERROR ["+IntToStr(Error)+"]";
    }
return str;
}
// --------------------------------------------------------------------------
// Func:            TDx_Play_Libray_ErrorMessage()
// Description:     Use this function to return information about the error.
// --------------------------------------------------------------------------
AnsiString __fastcall TDx_Play_Library_ErrorMessage(int Error)
{
AnsiString str = TDx_Library_ErrorMessage(Error);
if (str!="") return str;
switch (Error)
    {
    case -1: str = "You have attempted to call TDx_Play_Library component function before the component has been created. Refer to the help on the various TDx_Play_Library components Create() & Destroy() functions."; break;
    case DP_OK: str = "Ok."; break;
    case DPERR_ABORTED: str = "The operation was canceled before it could be completed."; break;
    case DPERR_ACCESSDENIED: str = "The session is full, or an incorrect password was supplied."; break;
    case DPERR_ACTIVEPLAYERS: str = "The requested operation cannot be performed because there are existing active players."; break;
    case DPERR_ALREADYINITIALIZED: str = "This object is already initialized."; break;
    case DPERR_ALREADYREGISTERED: str = "This object is already registered."; break;
    case DPERR_APPNOTSTARTED: str = "The application has not been started yet."; break;
    case DPERR_AUTHENTICATIONFAILED: str = "The password or credentials supplied could not be authenticated."; break;
    case DPERR_BUFFERTOOLARGE: str = "The data buffer is too large to store."; break;
    case DPERR_BUFFERTOOSMALL: str = "The supplied buffer is not large enough to contain the requested data."; break;
    case DPERR_BUSY: str = "A message cannot be sent because the transmission medium is busy."; break;
    case DPERR_CANCELFAILED: str = "The message could not be canceled, possibly because it is a group message that has already been to sent to one or more members of the group."; break;
    case DPERR_CANCELLED: str = "The operation was canceled."; break;
    case DPERR_CANNOTCREATESERVER: str = "The server cannot be created for the new session."; break;
    case DPERR_CANTADDPLAYER: str = "The player cannot be added to the session."; break;
    case DPERR_CANTCREATEGROUP: str = "A new group cannot be created."; break;
    case DPERR_CANTCREATEPLAYER: str = "A new player cannot be created."; break;
    case DPERR_CANTCREATEPROCESS: str = "Cannot start the application."; break;
    case DPERR_CANTCREATESESSION: str = "A new session cannot be created."; break;
    case DPERR_CANTLOADCAPI: str = "No credentials were supplied and the CryptoAPI package (CAPI) to use for cryptography services cannot be loaded."; break;
    case DPERR_CANTLOADSECURITYPACKAGE: str = "The software security package cannot be loaded."; break;
    case DPERR_CANTLOADSSPI: str = "No credentials were supplied, and the Security Support Provider Interface (SSPI) that will prompt for credentials cannot be loaded."; break;
    case DPERR_CAPSNOTAVAILABLEYET: str = "The capabilities of the DirectPlay object have not been determined yet. This error will occur if the DirectPlay object is implemented on a connectivity solution that requires polling to determine available bandwidth and latency."; break;
    case DPERR_CONNECTING: str = "The method is in the process of connecting to the network. The application should keep using the method until it returns DP_OK, indicating successful completion, or until it returns a different error."; break;
    case DPERR_CONNECTIONLOST: str = "The service provider connection was reset while data was being sent."; break;
    case DPERR_ENCRYPTIONFAILED: str = "The requested information could not be digitally encrypted. Encryption is used for message privacy. This error is only relevant in a secure session."; break;
    case DPERR_ENCRYPTIONNOTSUPPORTED: str = "The type of encryption requested in the DPSECURITYDESC structure is not available. This error is only relevant in a secure session."; break;
    case DPERR_EXCEPTION: str = "An exception occurred when processing the request."; break;
    case DPERR_GENERIC: str = "An undefined error condition occurred."; break;
    case DPERR_INVALIDFLAGS: str = "The flags passed to this method are invalid."; break;
    case DPERR_INVALIDGROUP: str = "The group ID is not recognized as a valid group ID for this game session."; break;
    case DPERR_INVALIDINTERFACE: str = "The interface parameter is invalid."; break;
    case DPERR_INVALIDOBJECT: str = "The DirectPlay object pointer is invalid."; break;
    case DPERR_INVALIDPARAMS: str = "One or more of the parameters passed to the method are invalid."; break;
    case DPERR_INVALIDPASSWORD: str = "An invalid password was supplied when attempting to join a session that requires a password."; break;
    case DPERR_INVALIDPLAYER: str = "The player ID is not recognized as a valid player ID for this game session."; break;
    case DPERR_INVALIDPRIORITY: str = "The specified priority is not within the range of allowed priorities, which is inclusively 0-65535."; break;
    case DPERR_LOGONDENIED: str = "The session could not be opened because credentials are required, and either no credentials were supplied, or the credentials were invalid."; break;
    case DPERR_NOCAPS: str = "The communication link that DirectPlay is attempting to use is not capable of this function."; break;
    case DPERR_NOCONNECTION: str = "No communication link was established."; break;
    case DPERR_NOINTERFACE: str = "The interface is not supported."; break;
    case DPERR_NOMEMORY: str = "There is not enough memory."; break;
    case DPERR_NOMESSAGES: str = "There are no messages in the receive queue."; break;
    case DPERR_NONAMESERVERFOUND: str = "No name server (host) could be found or created. A host must exist to create a player."; break;
    case DPERR_NONEWPLAYERS: str = "The session is not accepting any new players."; break;
    case DPERR_NOPLAYERS: str = "There are no active players in the session."; break;
    case DPERR_NOSERVICEPROVIDER: str = "There is no service provider."; break;
    case DPERR_NOSESSIONS: str = "There are no existing sessions for this game."; break;
    case DPERR_NOTHANDLED: str = "The request was not handled."; break;
    case DPERR_NOTLOBBIED: str = "Returned by the IDirectPlayLobby3::Connect method if the application was not started by using the IDirectPlayLobby3::RunApplication method, or if there is no DPLCONNECTION structure currently initialized for this DirectPlayLobby object."; break;
    case DPERR_NOTLOGGEDIN: str = "An action cannot be performed because a player or client application is not logged on. Returned by the IDirectPlay4::Send method when the client application tries to send a secure message without being logged on."; break;
    case DPERR_NOTREGISTERED: str = "Not registered."; break;
    case DPERR_PENDING: str = "Not an error, this return indicates that an asynchronous send has reached the point where it is successfully queued. See IDirectPlay4::SendEx for more information."; break;
    case DPERR_PLAYERLOST: str = "A player has lost the connection to the session."; break;
    case DPERR_SERVICEPROVIDERLOADED: str = "The service provider is loaded."; break;
    case DPERR_SENDTOOBIG: str = "The message being sent by the IDirectPlay4::Send method is too large."; break;
    case DPERR_SESSIONLOST: str = "The connection to the session has been lost."; break;
    case DPERR_SIGNFAILED: str = "The requested information could not be digitally signed. Digital signatures are used to establish the authenticity of messages."; break;
    case DPERR_TIMEOUT: str = "The operation could not be completed in the specified time."; break;
    case DPERR_UNAVAILABLE: str = "The requested function is not available at this time."; break;
    case DPERR_UNINITIALIZED: str = "The requested object has not been initialized."; break;
    case DPERR_UNKNOWNAPPLICATION: str = "An unknown application was specified."; break;
    case DPERR_UNKNOWNMESSAGE: str = "The message ID isn't valid. Returned from IDirectPlay4::CancelMessage if the ID of the message to be canceled is invalid."; break;
    case DPERR_UNSUPPORTED: str = "The function or feature is not available in this implementation or on this service provider. Returned from IDirectPlay4::GetGroupConnectionSettings and IDirectPlay4::SetGroupConnectionSettings if they are called from a session that is not a lobby session. Returned from IDirectPlay4::SendEx if the priority or time-out is set, and these are not supported by the service provider and DirectPlay protocol is not on. Returned from IDirectPlay4::GetMessageQueue if you check the send queue and this is not supported by the service provider and DirectPlay protocol is not on."; break;
    case DPERR_USERCANCEL: str = "Can be returned in two ways. 1) The user canceled the connection process during a call to the IDirectPlay4::Open method. 2) The user clicked Cancel in one of the DirectPlay service provider dialog boxes during a call to IDirectPlay4::EnumSessions."; break;
    default: str = "UNKNOWN ERROR ["+IntToStr(Error)+"]";
    }
return str;
}
// --------------------------------------------------------------------------
